import java.io.IOException;
import java.nio.ByteBuffer;
import java.nio.channels.FileChannel;
import java.nio.channels.FileChannel.MapMode;
import java.nio.file.Paths;

public class MapFile {
    private static final int OFFSET = 0;
    private static final int SIZE = 102400000;
    private static void test(String fnm, int expect) throws IOException {
        long t1 = System.currentTimeMillis();
        try(FileChannel fc = FileChannel.open(Paths.get(fnm))) {
            ByteBuffer bb = fc.map(MapMode.READ_ONLY, OFFSET, SIZE);
            bb.rewind();
            int n = 0;
            for(int ix = 0; ix < SIZE; ix++) {
                byte b = bb.get(ix);
                if(b == '\n') {
                    n++;
                }
            }
            if(n != expect) {
                System.out.printf("%d lines\n", n);
            }
        }
        long t2 = System.currentTimeMillis();
        System.out.printf("Java FileChannel.map file : %d ms\n", t2 - t1);
    }
    public static void main(String[] args) throws IOException {
        for(int i = 0; i < 10; i++) {
            test(args[0], Integer.parseInt(args[1]));
        }
    }
}
